struct AYSongInfo
{
  char Author[64]; /* Song author */
  char Name[64]; /* Song name */
  /*un*/signed long Length; /* Song length in 1/50 of second, negative value for unknown/infinite length */
  unsigned long Loop; /* Loop start position */
  void *data; /* used for players */
  void *data1; /* used for players */
  unsigned char *module; /* z80 memory or raw song data */
  unsigned char *module1; /* z80 memory or raw song data */
  unsigned char *file_data; /* z80 memory or raw song data */
  unsigned long file_len; /* file length */
  unsigned long module_len; /* file length */
  bool is_ts; /* 2xay - turbo sound */
};



enum
{
  AY_CHNL_A_FINE = 0, AY_CHNL_A_COARSE, AY_CHNL_B_FINE, AY_CHNL_B_COARSE, AY_CHNL_C_FINE, AY_CHNL_C_COARSE, AY_NOISE_PERIOD, AY_MIXER, AY_CHNL_A_VOL, AY_CHNL_B_VOL, AY_CHNL_C_VOL, AY_ENV_FINE, AY_ENV_COARSE, AY_ENV_SHAPE, AY_GPIO_A, AY_GPIO_B
};



void ay_resetay(AYSongInfo* ay, int chip)
{
  if (!chip) hway_reset();
}



void ay_writeay(AYSongInfo* ay, uint8_t reg, uint8_t val)
{
  hway_write_remap(0, reg, val);
}



void ay_writeay(AYSongInfo* ay, uint8_t reg, uint8_t val, uint8_t chip)
{
  if (!chip)
  {
    hway_write(0, reg, val);
  }
  else
  {
    hway_write(1, reg, val);
  }
}

unsigned char ay_readay(AYSongInfo* ay, uint8_t reg, uint8_t chip)
{
  if (reg < 16)
  {
    if (!chip) return hway_reg_1[reg]; else return hway_reg_2[reg];
  }

  return 0;
}



uint16_t ay_sys_getword(unsigned char* src)
{
  return src[0] + (src[1] << 8);
}



void ay_sys_writeword(unsigned char* dst, uint16_t val)
{
  dst[0] = val & 0xff;
  dst[1] = val >> 8;
}



void ay_sys_getstr(char* dst, unsigned int dst_size, unsigned char* src, unsigned int src_maxlen)
{
  memset(dst, 0, dst_size);

  for (int i = 0; i < src_maxlen; ++i)
  {
    char c = src[i];
    if (!c) break;
    dst[i] = c;
  }

  int i = strlen(dst) - 1;

  while (i >= 0)
  {
    if (dst[i] != ' ') break;
    dst[i--] = 0;
  }
}
