//jitter issue is solved by only showing the lowest charge level value registered in discharge mode
//it only allowed to get higher during charging

int8_t battery_lowest_charge;

void battery_init()
{
  battery_lowest_charge = 100;
}



int battery_level()
{
  const int16_t levels[40] = { //in 2.5% increments from 100 to 5
    //tests shows that >=4120 is charging, while 4100 is 100% charged
    4120 - 0 * 28, 4120 - 1 * 28, 4120 - 2 * 28, 4120 - 3 * 28, 4120 - 4 * 28,
    4120 - 5 * 28, 4120 - 6 * 28, 4120 - 7 * 28, 4120 - 8 * 28, 4120 - 9 * 28,
    4120 - 10 * 28, 4120 - 11 * 28, 4120 - 12 * 28, 4120 - 13 * 28, 4120 - 14 * 28,
    4120 - 15 * 28, 4120 - 16 * 28, 4120 - 17 * 28, 4120 - 18 * 28, 4120 - 19 * 28,
    4120 - 20 * 28, 4120 - 21 * 28, 4120 - 22 * 28, 4120 - 23 * 28, 4120 - 24 * 28,
    4120 - 25 * 28, 4120 - 26 * 28, 4120 - 27 * 28, 4120 - 28 * 28, 4120 - 29 * 28,
    4120 - 30 * 28, 4120 - 31 * 28, 4120 - 32 * 28, 4120 - 33 * 28, 4120 - 34 * 28,
    4120 - 35 * 28, 4120 - 36 * 28, 4120 - 37 * 28, 4120 - 38 * 28, 4120 - 39 * 28,
  };

  int16_t vol = (int16_t)((float)analogRead(A0) * (1000.0 - 77.0) * 0.00486);

  //Serial.println(vol);

  int charge = 0;

  if (vol > levels[0])
  {
    charge = 110; //charging
    battery_lowest_charge = charge;
  }
  else
  {
    for (int i = 0; i < sizeof(levels) / sizeof(int16_t); ++i)
    {
      if (vol >= levels[i])
      {
        charge = (10000 - i * (10000 / (sizeof(levels) / sizeof(int16_t)))) / 100;
        break;
      }
    }

    if (battery_lowest_charge < charge) charge = battery_lowest_charge; else battery_lowest_charge = charge;
  }

#ifndef DEBUG_BATTERY
  return charge;
#else
  return vol / 10;
#endif
}
